//
//  ViewController.swift
//  IOS10_oneNET&MQTT云平台
//
//  Created by lee on 2018/1/17.
//  Copyright © 2018年 物联网入门视频教程-IOS部分. All rights reserved.
//

import UIKit
import SnapKit
import CocoaMQTT
class ViewController: UIViewController {

    var labDev: UILabel!
    var labPro: UILabel!
    var labAuth: UILabel!
    var labTopic: UILabel!
    
    var textDev: UITextField!
    var textPro: UITextField!
    var textAuth: UITextField!
    var textTopic: UITextField!
    
    var textSendTopic: UITextField!
    var textData: UITextField!
    
    var btnCon: UIButton!
    var btnSend: UIButton!
    
    var textDisPlay: UITextField!
    
    var mqtt: CocoaMQTT!
    
    var conFlag: Bool = false
    override func viewDidLoad() {
        super.viewDidLoad()
        
        setup()
    }

}

//布局
extension ViewController: UITextFieldDelegate{
    
    func setup(){
        //deviceID对应的uilable的布局
        labDev = UILabel()
        labDev.text = "deviceID:"
        view.addSubview(labDev)
        
        labDev.snp.makeConstraints { (dev) in
            dev.top.equalTo(view.snp.top).offset(50)
            dev.left.equalTo(view.snp.left).offset(20)
            dev.width.equalTo(100)
            dev.height.equalTo(30)
        }
        
        //productID对应的UIlable的布局
        labPro = UILabel()
        labPro.text = "productID:"
        view.addSubview(labPro)
        
        labPro.snp.makeConstraints { (pro) in
            pro.top.equalTo(labDev.snp.bottom).offset(10)
            pro.left.equalTo(labDev.snp.left)
            pro.right.equalTo(labDev.snp.right)
            pro.height.equalTo(labDev.snp.height)
        }
        
        //authInfo对应的uilable的布局
        labAuth = UILabel()
        labAuth.text = "authInfo:"
        view.addSubview(labAuth)
        
        labAuth.snp.makeConstraints { (auth) in
            auth.top.equalTo(labPro.snp.bottom).offset(10)
            auth.left.equalTo(labPro.snp.left)
            auth.right.equalTo(labPro.snp.right)
            auth.height.equalTo(labPro.snp.height)
        }
        
        //订阅tipic对应的uilable
        labTopic = UILabel()
        labTopic.text = "订阅Topic:"
        view.addSubview(labTopic)
        
        labTopic.snp.makeConstraints { (topic) in
            topic.top.equalTo(labAuth.snp.bottom).offset(10)
            topic.left.equalTo(labAuth.snp.left)
            topic.right.equalTo(labAuth.snp.right)
            topic.height.equalTo(labAuth.snp.height)
        }
        
        //deviceID对应的uitextfield
        textDev = UITextField()
        textDev.placeholder = "deviceID"
        textDev.borderStyle = UITextBorderStyle.line
        textDev.delegate = self
        view.addSubview(textDev)
        
        textDev.snp.makeConstraints { (dev) in
            dev.top.equalTo(labDev.snp.top)
            dev.bottom.equalTo(labDev.snp.bottom)
            dev.left.equalTo(labPro.snp.right).offset(10)
            dev.right.equalTo(view.snp.right).offset(-20)
        }
        
        //productID对应的uitextfield
        textPro = UITextField()
        textPro.placeholder = "productID"
        textPro.borderStyle = UITextBorderStyle.line
        textPro.delegate = self
        view.addSubview(textPro)
        
        textPro.snp.makeConstraints { (pro) in
            pro.top.equalTo(labPro.snp.top)
            pro.bottom.equalTo(labPro.snp.bottom)
            pro.left.equalTo(textDev.snp.left)
            pro.right.equalTo(textDev.snp.right)
        }
        
        //authinfo对应的uitextfield
        textAuth = UITextField()
        textAuth.placeholder = "authInfo"
        textAuth.borderStyle = UITextBorderStyle.line
        textAuth.delegate = self
        view.addSubview(textAuth)
        
        textAuth.snp.makeConstraints { (auth) in
            auth.top.equalTo(labAuth.snp.top)
            auth.bottom.equalTo(labAuth.snp.bottom)
            auth.left.equalTo(textPro.snp.left)
            auth.right.equalTo(textPro.snp.right)
        }
        
        //订阅topci对应的uitextfield
        textTopic = UITextField()
        textTopic.placeholder = "Topic"
        textTopic.borderStyle = UITextBorderStyle.line
        textTopic.delegate = self
        view.addSubview(textTopic)
        
        textTopic.snp.makeConstraints { (topic) in
            topic.top.equalTo(labTopic.snp.top)
            topic.bottom.equalTo(labTopic.snp.bottom)
            topic.left.equalTo(textAuth.snp.left)
            topic.right.equalTo(textAuth.snp.right)
        }
        
        //发送topic对应的uitextfield
        textSendTopic = UITextField()
        textSendTopic.placeholder = "Topic..."
        textSendTopic.borderStyle = UITextBorderStyle.line
        textSendTopic.delegate = self
        view.addSubview(textSendTopic)
        
        textSendTopic.snp.makeConstraints { (topic) in
            topic.top.equalTo(labTopic.snp.bottom).offset(10)
            topic.height.equalTo(textDev.snp.height)
            topic.left.equalTo(labDev.snp.left)
            topic.right.equalTo(view.snp.centerX).offset(-40)
        }
        
        //发送的信息对应的uitextfield
        textData = UITextField()
        textData.placeholder = "想要发送的信息..."
        textData.borderStyle = UITextBorderStyle.line
        textData.delegate = self
        view.addSubview(textData)
        
        textData.snp.makeConstraints { (data) in
            data.top.equalTo(textSendTopic.snp.top)
            data.bottom.equalTo(textSendTopic.snp.bottom)
            data.left.equalTo(textSendTopic.snp.right).offset(10)
            data.right.equalTo(textDev.snp.right)
        }
        
        //实例化连接按钮
        btnCon = UIButton()
        btnCon.setTitle("已断开", for: UIControlState.normal)
        btnCon.backgroundColor = UIColor.lightGray
        view.addSubview(btnCon)
        
        //绑定监听方法
        btnCon.addTarget(self, action: #selector(connect), for: UIControlEvents.touchUpInside)
        
        btnCon.snp.makeConstraints { (con) in
            con.top.equalTo(textSendTopic.snp.bottom).offset(10)
            con.left.equalTo(labDev.snp.left)
            con.right.equalTo(view.snp.centerX).offset(-10)
            con.height.equalTo(labDev.snp.height)
        }
        
        //实例化发送按钮
        btnSend = UIButton()
        btnSend.setTitle("发送", for: UIControlState.normal)
        btnSend.setTitle("已发送", for: UIControlState.highlighted)
        btnSend.backgroundColor = UIColor.lightGray
        view.addSubview(btnSend)
        
        //绑定监听方法
        btnSend.addTarget(self, action: #selector(send), for: UIControlEvents.touchUpInside)
        
        btnSend.snp.makeConstraints { (send) in
            send.top.equalTo(btnCon.snp.top)
            send.bottom.equalTo(btnCon.snp.bottom)
            send.left.equalTo(view.snp.centerX).offset(10)
            send.right.equalTo(textDev.snp.right)
        }
        
        textDisPlay = UITextField()
        textDisPlay.borderStyle = UITextBorderStyle.line
        textDisPlay.contentVerticalAlignment = UIControlContentVerticalAlignment.top
        
        view.addSubview(textDisPlay)
        textDisPlay.snp.makeConstraints { (display) in
            display.top.equalTo(btnCon.snp.bottom).offset(10)
            display.left.equalTo(btnCon.snp.left)
            display.right.equalTo(btnSend.snp.right)
            display.bottom.equalTo(view.snp.bottom).offset(-20)
        }
    }
    
    func textFieldShouldReturn(_ textField: UITextField) -> Bool {
        textField.resignFirstResponder()
        return true
    }

    override func touchesBegan(_ touches: Set<UITouch>, with event: UIEvent?) {
        view.endEditing(true)
    }
}

//两个按钮的监听方法
extension ViewController:CocoaMQTTDelegate{
    func connect(){
    
        let deviceId: String! = textDev.text
        let productId: String! = textPro.text
        let authInfo: String! = textAuth.text
        
        
        if(conFlag == false){
            //clientID:指的就是设备ID
            //host:指的是域名
            //port:指的是连接的端口
            mqtt = CocoaMQTT(clientID: deviceId, host: "183.230.40.39", port: 6002)
            //username指的是产品ID
            mqtt.username = productId
            //password:指的是设备的鉴权信息
            mqtt.password = authInfo
            mqtt.keepAlive = 120
            mqtt.delegate = self
            
            mqtt.connect()
            conFlag = true
            btnCon.setTitle("已连接", for: UIControlState.normal)
        }else{
        
            mqtt.disconnect()
            conFlag = false
            btnCon.setTitle("已断开", for: UIControlState.normal)
        }
        
        
        
    }
    
    func send(){
    
        let data: String! = textData.text
        let topic: String! = textSendTopic.text
        mqtt.publish(topic, withString: data)
    }
    //表示是否连接成功，返回连接状态（或者连接失败的原因）
    func mqtt(_ mqtt: CocoaMQTT, didConnectAck ack: CocoaMQTTConnAck){
        
        //如果连接成功
        if(ack == CocoaMQTTConnAck.accept){
        
            let topic:String! = textTopic.text
            mqtt.subscribe(topic, qos: CocoaMQTTQOS.qos0)
        }
    }
    
    //表示发送的信息
    func mqtt(_ mqtt: CocoaMQTT, didPublishMessage message: CocoaMQTTMessage, id: UInt16){
        print("已发送\(message.string ?? "")")
    }
    
    //表示是否发送成功
    func mqtt(_ mqtt: CocoaMQTT, didPublishAck id: UInt16){
        
        print("发送成功")
    }
    //接收到的信息
    func mqtt(_ mqtt: CocoaMQTT, didReceiveMessage message: CocoaMQTTMessage, id: UInt16 ){
        
        print("收到的信息：\(message.string ?? "")")
        textDisPlay.text = message.string ?? ""
    }
    //表示订阅的topic
    func mqtt(_ mqtt: CocoaMQTT, didSubscribeTopic topic: String){
    }
    //表示取消订阅的topic
    func mqtt(_ mqtt: CocoaMQTT, didUnsubscribeTopic topic: String){
    }
    func mqttDidPing(_ mqtt: CocoaMQTT){
    }
    func mqttDidReceivePong(_ mqtt: CocoaMQTT){
    }
    //表示连接已断开
    func mqttDidDisconnect(_ mqtt: CocoaMQTT, withError err: Error?){
    }

    
}
